%close all
%clear all
function [Q] = InverseKinematics(phi, theta, psi, x, y, z)
% input data: position of robot's end efffector and orientation (ZYZ
% Euler)
% phi= 0.1;
% theta = pi/2;
% psi= 0.1;
% 
 O2 = [x; y; z]; %[380;00;300]./1000;


o = O2;

d1 = .4865;
d4 = .600;
d6 = .065;
a1 = .15;
a2 = .475;

% DH parameters
th = [0; -(1/2)*pi; 0; 0; pi; 0];
d = [d1; 0; 0; d4; 0; d6];
a = [a1; a2; 0; 0; 0; 0];
alpha = [-(1/2)*pi; 0; -(1/2)*pi; (1/2)*pi; (1/2)*pi; 0];
           
% shoulder offset 
offset = 0;

% auxliary data
R = [(cos(phi)*cos(theta)*cos(psi)-sin(phi)*sin(psi))  (-cos(phi)*cos(theta)*sin(psi)-sin(phi)*cos(psi)) (cos(phi)*sin(theta));
     (sin(phi)*cos(theta)*cos(psi)+cos(phi)*sin(psi))  (-sin(phi)*cos(theta)*sin(psi)+cos(phi)*cos(psi)) (sin(phi)*sin(theta));
     -sin(theta)*cos(psi)                                                 sin(theta)*sin(psi)                   cos(theta)  ];
      
x = o(1) - d(6)*R(1,3);
y = o(2) - d(6)*R(2,3);
z = o(3) - d(6)*R(3,3);

P0 = [x;y;z];

% Solving Q1   
th1 = atan2(y,x);
% Solving th3
r = sqrt((x-a(1).*cos(th1)).^2+(y-a(1).*sin(th1)).^2);
s = z-d(1);
D = ((r.^2)+(s.^2)-a(2).^2-( sqrt((d(4))^2 + (a(3))^2) ).^2)./(2*a(2)*(( sqrt((d(4))^2 + (a(3))^2) )));
%th3_3 = (-atan2(-sqrt(1-D.^2),D)-pi/2) + atan2(a(3),d(4))

th3 = acos(D)-pi/2 + atan2(a(3),d(4)); 


%th3_2 = -atan2(sqrt(1-D^2), -D) + pi/2
%th3_4 = -atan2(-sqrt(1-D.^2),D) - pi/2
% Solving th2
th2 = -atan2(s,r)+atan2((sqrt((d(4))^2 + (a(3))^2))*sin(-th3-pi/2+atan2(a(3),d(4))),a(2)+(sqrt((d(4))^2 + (a(3))^2))*cos(-th3-pi/2+atan2(a(3),d(4))))+pi/2 ;
%th2_2 = -atan2(s,r) + atan2(d(4)*sin(-th3 - pi/2), a(2) + d(4)*cos(-th3 - pi/2)) + pi/2
% output data -- DH joint variables
Q(1) = th1;
Q(3) = th3;
Q(2) = th2;

%Q 4,5,6 as Euler angles
DHMatrix1 = [ cos(Q(1) + th(1))      -cos(alpha(1))*sin(Q(1) + th(1))     sin(alpha(1))*sin(Q(1) + th(1))     a(1)*cos(Q(1) + th(1));
                   sin(Q(1) + th(1))       cos(alpha(1))*cos(Q(1) + th(1))    -sin(alpha(1))*cos(Q(1) + th(1))     a(1)*sin(Q(1) + th(1));
                             0               sin(alpha(1))                         cos(alpha(1))                             d(1)                ;
                             0                                     0                                0                                    1       ]; 
                         
                         
DHMatrix2 = [ cos(Q(2) + th(2))      -cos(alpha(2))*sin(Q(2) + th(2))     sin(alpha(2))*sin(Q(2) + th(2))     a(2)*cos(Q(2) + th(2));
                   sin(Q(2) + th(2))       cos(alpha(2))*cos(Q(2) + th(2))    -sin(alpha(2))*cos(Q(2) + th(2))     a(2)*sin(Q(2) + th(2));
                             0               sin(alpha(2))                         cos(alpha(2))                             d(2)                ;
                             0                                     0                                0                                    1       ]; 
                         
DHMatrix3 = [ cos(Q(3) + th(3))      -cos(alpha(3))*sin(Q(3) + th(3))     sin(alpha(3))*sin(Q(3) + th(3))     a(3)*cos(Q(3) + th(3));
                   sin(Q(3) + th(3))       cos(alpha(3))*cos(Q(3) + th(3))    -sin(alpha(3))*cos(Q(3) + th(3))     a(3)*sin(Q(3) + th(3));
                             0               sin(alpha(3))                         cos(alpha(3))                             d(3)                ;
                             0                                     0                                0                                    1       ];
                         

E4 = [0 0 d(4) 1];
R03_ = DHMatrix1*DHMatrix2*DHMatrix3;
R03 = R03_(1:3,1:3);
R33 = (R03')*R;
P1 = R03_*E4';

Q(5) = -atan2(sqrt(R33(1,3)^2+R33(2,3)^2),R33(3,3));
Q(5) = atan2(-sqrt(R33(1,3)^2+R33(2,3)^2),R33(3,3));
Q(4) = atan2(R33(2,3),R33(1,3));
Q(6) = atan2(R33(3,2),-R33(3,1))-pi;

% % validation = proverka
%    DH_Matrix1 = [ cos(Q(1) + th(1))      -cos(alpha(1))*sin(Q(1) + th(1))     sin(alpha(1))*sin(Q(1) + th(1))     a(1)*cos(Q(1) + th(1));
%                    sin(Q(1) + th(1))       cos(alpha(1))*cos(Q(1) + th(1))    -sin(alpha(1))*cos(Q(1) + th(1))     a(1)*sin(Q(1) + th(1));
%                              0               sin(alpha(1))                         cos(alpha(1))                             d(1)                ;
%                              0                                     0                                0                                    1       ]; 
%                          
%                          
%    DH_Matrix2 = [ cos(Q(2) + th(2))      -cos(alpha(2))*sin(Q(2) + th(2))     sin(alpha(2))*sin(Q(2) + th(2))     a(2)*cos(Q(2) + th(2));
%                    sin(Q(2) + th(2))       cos(alpha(2))*cos(Q(2) + th(2))    -sin(alpha(2))*cos(Q(2) + th(2))     a(2)*sin(Q(2) + th(2));
%                              0               sin(alpha(2))                         cos(alpha(2))                             d(2)                ;
%                              0                                     0                                0                                    1       ]; 
%                          
%    DH_Matrix3 = [ cos(Q(3) + th(3))      -cos(alpha(3))*sin(Q(3) + th(3))     sin(alpha(3))*sin(Q(3) + th(3))     a(3)*cos(Q(3) + th(3));
%                    sin(Q(3) + th(3))       cos(alpha(3))*cos(Q(3) + th(3))    -sin(alpha(3))*cos(Q(3) + th(3))     a(3)*sin(Q(3) + th(3));
%                              0               sin(alpha(3))                         cos(alpha(3))                             d(3)                ;
%                              0                                     0                                0                                    1       ];
%                          
%    DH_Matrix4 = [ cos(Q(4) + th(4))      -cos(alpha(4))*sin(Q(4) + th(4))     sin(alpha(4))*sin(Q(4) + th(4))     a(4)*cos(Q(4) + th(4));
%                    sin(Q(4) + th(4))       cos(alpha(4))*cos(Q(4) + th(4))    -sin(alpha(4))*cos(Q(4) + th(4))     a(4)*sin(Q(4) + th(4));
%                              0               sin(alpha(4))                         cos(alpha(4))                             d(4)                ;
%                              0                                     0                                0                                    1       ]; 
%                          
%     DH_Matrix5 = [ cos(Q(5) + th(5))      -cos(alpha(5))*sin(Q(5) + th(5))     sin(alpha(5))*sin(Q(5) + th(5))     a(5)*cos(Q(5) + th(5));
%                    sin(Q(5) + th(5))       cos(alpha(5))*cos(Q(5) + th(5))    -sin(alpha(5))*cos(Q(5) + th(5))     a(5)*sin(Q(5) + th(5));
%                              0               sin(alpha(5))                         cos(alpha(5))                             d(5)                ;
%                              0                                     0                                0                                    1       ];  
%                          
%     DH_Matrix6 = [ cos(Q(6) + th(6))      -cos(alpha(6))*sin(Q(6) + th(6))     sin(alpha(6))*sin(Q(6) + th(6))     a(6)*cos(Q(6) + th(6));
%                    sin(Q(6) + th(6))       cos(alpha(6))*cos(Q(6) + th(6))    -sin(alpha(6))*cos(Q(6) + th(6))     a(6)*sin(Q(6) + th(6));
%                              0               sin(alpha(6))                         cos(alpha(6))                             d(6)                ;
%                              0                                     0                                0                                    1       ];  
%                       
%    DH  = DH_Matrix1;
%    P1 = DH(1:3,4);
%    DH  = DH_Matrix1*DH_Matrix2;
%    P2 = DH(1:3,4);
%    DH  = DH_Matrix1*DH_Matrix2*DH_Matrix3;
%    P3 = DH(1:3,4);
%    DH  = DH_Matrix1*DH_Matrix2*DH_Matrix3*DH_Matrix4;
%    P4 = DH(1:3,4);
%    DH  = DH_Matrix1*DH_Matrix2*DH_Matrix3*DH_Matrix4*DH_Matrix5;
%    P5 = DH(1:3,4);
%    DH  = DH_Matrix1*DH_Matrix2*DH_Matrix3*DH_Matrix4*DH_Matrix5*DH_Matrix6;
%    P6 = DH(1:3,4);
%    
%    x6 = DH*[0.1;0;0;1];
%    y6 = DH*[0;0.1;0;1];
%    z6 = DH*[0;0;0.1;1];
%    o6 = DH*[0;0;0;1];
%    
%    error = P6 - o;
% 
%    P0 = [0;0;0];
% %% graph
% sizetext = 8;
% 
% figure(1)
% set(gca, 'FontSize', sizetext)
% plot3(o(1), o(2), o(3),'k*','LineWidth',2), hold on
% plot3([P1(1) P2(1) P3(1) P4(1) P5(1) P6(1)],...
%       [P1(2) P2(2) P3(2) P4(2) P5(2) P6(2)],... 
%       [P1(3) P2(3) P3(3) P4(3) P5(3) P6(3)],'r*','LineWidth',2);
% plot3([P0(1) P1(1)], [P0(2) P1(2)], [P0(3) P1(3)],'b-','LineWidth',2);
% plot3([P1(1) P2(1)], [P1(2) P2(2)], [P1(3) P2(3)],'b-','LineWidth',2);
% plot3([P2(1) P3(1)], [P2(2) P3(2)], [P2(3) P3(3)],'b-','LineWidth',2);
% plot3([P3(1) P4(1)], [P3(2) P4(2)], [P3(3) P4(3)],'b-','LineWidth',2);
% plot3([P4(1) P5(1)], [P4(2) P5(2)], [P4(3) P5(3)],'b-','LineWidth',2);
% plot3([P5(1) P6(1)], [P5(2) P6(2)], [P5(3) P6(3)],'b-','LineWidth',2);
% 
% plot3([o6(1) x6(1)],[o6(2) x6(2)],[o6(3) x6(3)], 'r') %'b')
% plot3([o6(1) y6(1)],[o6(2) y6(2)],[o6(3) y6(3)],'g')
% plot3([o6(1) z6(1)],[o6(2) z6(2)],[o6(3) z6(3)],'b')%'r')
% 
% grid on;
% xlabel('X [m]'); ylabel('Y [m]'); zlabel('Z [m]');
% axis equal